#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=JoyTunes.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=JoyTunes
#AutoIt3Wrapper_Res_Description=JoyTunes
#AutoIt3Wrapper_Res_Fileversion=0.6.0.0
#AutoIt3Wrapper_Res_LegalCopyright=2010 Michael Michta
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#Region
#EndRegion
#Region
#EndRegion
#Region
#EndRegion

#Region:::Includes and options
#NoAutoIt3Execute
#include <ComboConstants.au3>
#include <TabConstants.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <WindowsConstants.au3>
#include <GUIConstants.au3>
#include <Misc.au3>
#include "_Joy.au3"
#include "_ArraySearchAnyDim.au3"
#include "_CB.au3"
#include "Tray.au3"
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)
Global $VerInfo = "0.6B"
#EndRegion

_Singleton("JoyTunes-4FC832E473A99359F6CF93A2566BB550");Ensure only one copy will run at a time

#Region:::Hook iTunes COM object
Global $oiTunes = ObjCreate("iTunes.Application")
If Not IsObj($oiTunes) Then
	MsgBox(0, "Error", "Failed to create and/or hook iTunes COM object.")
	Exit
EndIf
#EndRegion


#Region:::Prevent crash if iTunes returns a COM error
$oError = ObjEvent("AutoIt.Error", "comerror")
#EndRegion

#Region:::Call funtion to initialize joystick
$joy = _JoyInit()
#EndRegion

#Region:::Read settings
If Not FileExists(@ScriptDir & "\JoyTunes.ini") Then FileWrite(@ScriptDir & "\JoyTunes.ini", BinaryToString("0x3B444F204E4F54204D4F4449465920544849532046494C45204D414E55414C4C590D0A5B416374696F6E735D0D0A506C617950617573653D427574746F6E310D0A4E657874547261636B3D52696768740D0A50726576547261636B3D4C6566740D0A566F6C55703D55700D0A566F6C446F776E3D446F776E"));Write default ini
Global $Actions = IniReadSection(@ScriptDir & "\JoyTunes.ini", "Actions")
Global $Actions = IniReadSection(@ScriptDir & "\JoyTunes.ini", "Actions")
Global $OptJoyNum = IniRead(@ScriptDir & "\JoyTunes.ini", "Settings", "JoyNum", 0)
Global $OptPrevRepeat = IniRead(@ScriptDir & "\JoyTunes.ini", "Settings", "PreventRepeat", 0)
Global $CheckX, $CheckY, $CheckZ, $CheckR, $CheckU, $CheckV
CheckAxes($CheckX, $CheckY, $CheckZ, $CheckR, $CheckU, $CheckV)
#EndRegion

#Region:::Build tray menu
TrayCreateItem("Settings...")
TrayItemSetOnEvent(-1, "Tray_Settings")
TrayCreateItem("Exit")
TrayItemSetOnEvent(-1, "Tray_Exit")
#EndRegion


#Region:::Main loop
While 1
	Sleep(150)
	$Array = _GetJoy($joy, $OptJoyNum)

	#Region:::Check Buttons
	$N = 1
	For $X = 1 To 16
		If BitAND($Array[7], $N) Then
			Action("Button" & $X)
			StopRepeatB($N)
		EndIf
		$N *= 2
	Next
	#EndRegion

	#Region:::Check POV
	Switch $Array[6]
		Case 0
			Action("Up")
			StopRepeatP(0)
		Case 18000
			Action("Down")
			StopRepeatP(18000)
		Case 27000
			Action("Left")
			StopRepeatP(27000)
		Case 9000
			Action("Right")
			StopRepeatP(9000)
		Case 4500
			Action("Up-Right")
			StopRepeatP(4500)
		Case 31500
			Action("Up-Left")
			StopRepeatP(31500)
		Case 13500
			Action("Down-Right")
			StopRepeatP(13500)
		Case 22500
			Action("Down-Left")
			StopRepeatP(22500)
	EndSwitch
	#EndRegion

	#Region:::Check X
	If $CheckX = 1 Then
		Switch $Array[0]
			Case 0
				Action("X-")
				StopRepeatA(0, 0)
			Case 65535
				Action("X+")
				StopRepeatA(65535, 0)
		EndSwitch
	EndIf
	#EndRegion


	#Region:::Check Y
	If $CheckY = 1 Then
		Switch $Array[1]
			Case 0
				Action("Y-")
				StopRepeatA(0, 1)
			Case 65535
				Action("Y+")
				StopRepeatA(65535, 1)
		EndSwitch
	EndIf
	#EndRegion

	#Region:::Check Z
	If $CheckZ = 1 Then
		Switch $Array[2]
			Case 0
				Action("Z-")
				StopRepeatA(0, 2)
			Case 65535
				Action("Z+")
				StopRepeatA(65535, 2)
		EndSwitch
	EndIf
	#EndRegion

	#Region:::Check R
	If $CheckR = 1 Then
		Switch $Array[3]
			Case 0
				Action("R-")
				StopRepeatA(0, 3)
			Case 65535
				Action("R+")
				StopRepeatA(65535, 3)
		EndSwitch
	EndIf
	#EndRegion

	#Region:::Check U
	If $CheckU = 1 Then
		Switch $Array[4]
			Case 0
				Action("U-")
				StopRepeatA(0, 4)
			Case 65535
				Action("U+")
				StopRepeatA(65535, 4)
		EndSwitch
	EndIf
	#EndRegion

	#Region:::Check V
	If $CheckV = 1 Then
		Switch $Array[5]
			Case 0
				Action("V-")
				StopRepeatA(0, 5)
			Case 65535
				Action("V+")
				StopRepeatA(65535, 5)
		EndSwitch
	EndIf
	#EndRegion
WEnd
#EndRegion

#Region:::Function to prevent POV repeat when $OptPrevRepeat is 1
Func StopRepeatP($Value)
	Switch $OptPrevRepeat
		Case 0
			Sleep(100)
		Case 1
			Do
				$Array = _GetJoy($joy, $OptJoyNum)
				Sleep(25)
			Until $Array[6] <> $Value
	EndSwitch
EndFunc   ;==>StopRepeatP
#EndRegion

#Region:::Function to prevent Button repeat when $OptPrevRepeat is 1
Func StopRepeatB($Value)
	Switch $OptPrevRepeat
		Case 0
			Sleep(100)
		Case 1
			Do
				$Array = _GetJoy($joy, $OptJoyNum)
				Sleep(25)
			Until Not BitAND($Array[7], $Value)
	EndSwitch
EndFunc   ;==>StopRepeatB
#EndRegion

#Region:::Function to prevent axes repeat when $OptPrevRepeat is 1
Func StopRepeatA($Value, $Axe)
	Switch $OptPrevRepeat
		Case 0
			Sleep(100)
		Case 1
			Do
				$Array = _GetJoy($joy, $OptJoyNum)
				Sleep(25)
			Until $Array[$Axe] <> $Value
	EndSwitch
EndFunc   ;==>StopRepeatA
#EndRegion

#Region:::Function to handle when POV or button or button is pressed
Func Action($Name)
	$Search = _ArraySearchAnyDim($Actions, $Name, 1, 0, 0, "[x][1]")
	If $Search = -1 Then Return
	Switch $Actions[$Search][0]
		Case "PlayPause"
			$oiTunes.PlayPause
		Case "NextTrack"
			$oiTunes.NextTrack
			$oiTunes.Play
		Case "PrevTrack"
			$oiTunes.PreviousTrack
			$oiTunes.Play
		Case "VolUp"
			AdjustVolume("+")
		Case "VolDown"
			AdjustVolume("-")
	EndSwitch
EndFunc   ;==>Action
#EndRegion


#Region:::Functions to see which axes the joystick has
Func CheckAxes(ByRef $X, ByRef $Y, ByRef $Z, ByRef $R, ByRef $U, ByRef $V)
	$Array = _GetJoy($joy, $OptJoyNum)
	Switch $Array[0]
		Case 0
			$X = 0
		Case Else
			$X = 1
	EndSwitch

	Switch $Array[1]
		Case 0
			$Y = 0
		Case Else
			$Y = 1
	EndSwitch

	Switch $Array[2]
		Case 0
			$Z = 0
		Case Else
			$Z = 1
	EndSwitch

	Switch $Array[3]
		Case 0
			$R = 0
		Case Else
			$R = 1
	EndSwitch

	Switch $Array[4]
		Case 0
			$U = 0
		Case Else
			$U = 1
	EndSwitch

	Switch $Array[5]
		Case 0
			$V = 0
		Case Else
			$V = 1
	EndSwitch

EndFunc   ;==>CheckAxes
#EndRegion

#Region:::Function for adjusting iTunes volume
Func AdjustVolume($Mode)
	Local $Volume = $oiTunes.SoundVolume
	Select
		Case $Mode = "-"
			$oiTunes.SoundVolume = $Volume - 5
		Case $Mode = "+"
			$oiTunes.SoundVolume = $Volume + 5
	EndSelect
EndFunc   ;==>AdjustVolume
#EndRegion

#Region:::Dummy function to catch com errors
Func comerror()
EndFunc   ;==>comerror
#EndRegion